#ifndef PKGCONFIGGENERATOR_H_
#define PKGCONFIGGENERATOR_H_

#include "internaltask.h"
#include "tool.h"

class PkgConfigFile;

class PkgConfigGenerator: public Tool
{
private:
	class Worker: public InternalTask::Worker
	{
	private:
		const PkgConfigFile &target;

	public:
		Worker(const PkgConfigFile &);

	private:
		virtual void main();

		std::string prefixify(const Msp::FS::Path &, const Msp::FS::Path &);
	};

public:
	PkgConfigGenerator(Builder &);

	virtual Target *create_target(const std::list<Target *> &, const std::string &);
	virtual Task *run(const Target &) const;
};

#endif
